"""
Auto generated by Mercado Radar SDK Generator
2025-02-27 21:38:42
"""
from typing import Optional, List, Any

from ..models._paginated_response import PaginatedResponse
from ..models._ticket import Ticket as TicketSchema


class Ticket:

    def __init__(self, client):
        self.client = client

    def list(self, responsible_id: int, customer_id: int, status: List[Any], category: List[Any], created_at_after: str,
             created_at_before: str, closed_at_after: str, closed_at_before: str, days_open_min: str,
             days_open_max: str, limit: int, offset: int) -> PaginatedResponse[TicketSchema]:
        """
        List all Tickets

        List all Tickets
        """
        data = {
            "responsible_id": responsible_id,
            "customer_id": customer_id,
            "status": status,
            "category": category,
            "created_at_after": created_at_after,
            "created_at_before": created_at_before,
            "closed_at_after": closed_at_after,
            "closed_at_before": closed_at_before,
            "days_open_min": days_open_min,
            "days_open_max": days_open_max,
            "limit": limit,
            "offset": offset,
        }
        data = {k: v for k, v in data.items() if v is not None}

        response = self.client.get(url=f"/v3/ticket/", params=data)

        response.raise_for_status()

        data = response.json()

        count = data.get('count', 0)
        next_page = data.get('next')
        previous_page = data.get('previous')
        results = data.get('results')

        parsed_results = []
        for result in results:
            parsed_results.append(TicketSchema(**result))

        parsed_paginated_response = {"count": count, "next": next_page, "previous": previous_page,
                                     "results": parsed_results}

        return PaginatedResponse(**parsed_paginated_response)

    def create(self, title: str, description: str, customer: Optional[Any] = None, opened_by_user: Any) -> TicketSchema:
        """
        Create a new Ticket

        Creates a new Ticket
        """
        data = {
            "title": title,
            "description": description,
            "customer": customer,
            "opened_by_user": opened_by_user,
        }
        data = {k: v for k, v in data.items() if v is not None}

        response = self.client.post(url=f"/v3/ticket/", json=data)

        response.raise_for_status()

        return TicketSchema(**response.json())

    def retrieve(self, id: int) -> TicketSchema:
        """
        Retrieve a Ticket by ID

        Retrieve a Ticket by ID
        """

        response = self.client.get(url=f"/v3/ticket/{id}/")

        response.raise_for_status()

        return TicketSchema(**response.json())

    def update(self, id: int, title: str, description: str, customer: Optional[Any] = None,
               opened_by_user: Any) -> TicketSchema:
        """
        Partially update a Ticket by ID

        Partially update a Ticket by ID
        """
        data = {
            "id": id,
            "title": title,
            "description": description,
            "customer": customer,
            "opened_by_user": opened_by_user,
        }
        data = {k: v for k, v in data.items() if v is not None}

        response = self.client.patch(url=f"/v3/ticket/{id}/", json=data)

        response.raise_for_status()

        return TicketSchema(**response.json())

    def destroy(self, id: int) -> TicketSchema:
        """
        Delete a Ticket by ID

        Delete a Ticket by ID
        """

        response = self.client.delete(url=f"/v3/ticket/{id}/")

        response.raise_for_status()

        return TicketSchema(**response.json())
